/* -*- mode: c++; c-basic-offset: 4; -*- */
#ifndef CONTAINER_DFT_HH
#define CONTAINER_DFT_HH

#include "fSeries.hh"
class TSeries;

namespace containers {

class DFT : public fSeries {
public:
    DFT(void);
    DFT(const TSeries& ts);
    DFT(const fSeries& fs);
    ~DFT(void);
    DFT* clone(void) const;
    DFT evolve(Interval dt) const;
    fSeries::FSType getFSType(void) const;
    void setData(const TSeries& ts);
};

//======================================  Inline methods
inline fSeries::FSType 
DFT::getFSType(void) const {
    return fSeries::kDFT;
}

} //  namespace containers

#endif // !defined(CONTAINER_DFT_HH)
