#ifndef HTML_FONT_HH
#define HTML_FONT_HH

#include "html/Attrib.hh"
#include <string>

namespace html {
  class writer;

  class font : public attrib {
  public:
    font(void);
    font(const std::string& face);
    font(const font& x);
    ~font(void);
    attrib* clone(void) const;
    bool isDefault(void) const;
    void putAttr(writer& w) const;
    bool operator==(const font& x) const;
    void setDefault(void);
    void setFace(const std::string& name);
    const char* getFace(void) const;
  private:
    std::string mFace;
  };

}

inline bool
html::font::operator==(const html::font& x) const {
    return mFace == x.mFace;
}

inline const char*
html::font::getFace(void) const {
    return mFace.c_str();
}

#endif //  HTML_FONT_HH
