#ifndef BandMonitor_HH
#define BandMonitor_HH

#include "DatEnv.hh"
#include "MonServer.hh"

//
//    Data Monitor template class.
//    Class DatTemplate inherits member functions both from
//    Class DatEnv and from Class MonServer
//
class BandMonitor : public DatEnv , public MonServer {
public:
  int MaxFrame;               //  Number of frames I should process
  
  BandMonitor(int argc, const char *argv[]);  // Constructor
  ~BandMonitor();                             // Destructor
  void ProcessData(void);
  void Attention(void);
  void DumpHelp(void);
private:

  // trend add-on
  bool make_trends;
  bool make_trend_index;
  std::vector<std::string> trend_channel_list;
  Trend* pblrmsTrend;
  std::string trend_name;
  // end trend add-on
  // KSG 8/25/05 add-ons to accomadate new output channel names
  std::string trend_name_new;
  // end add-on by KSG for new names
  // addon flag to allow for no text file writing
  bool make_text_file;
  // end of addon for no text file writing

  // original private data members for band limited rms monitor
  TSeries** ts;
  RmsConfig* rmspar;
  int are_filters_initialized;
  int count_seconds;
  int* srate;
  int number_of_filter_outputs;
  Chan_filtset* filters;
  Rms_output* file_output;
  int segment_counter;
  float* data_store;
  int column_tally;
  int column_count;
  int data_error;
  long int total_seconds_to_run;
  long int second_counter;
  bool first_reading_done;
  Time tnow;
  Interval time_per_rms_reading;

  char* monitor_names;
  int max_monitor_name_length;
  char* mon_name_buf;
  int monitor_length;
  float* monitor_init;
  TSeries** monitor_tseries;

  FILE* uout;
  //jzweizig defined the variable below about 9/04 to help with gap checking
  Time mLast_t0;
  // The following variables defined by ksg about 10/24/04 to check for gaps 
  int  mNconsecutive;
  int  mNconsecutive_last;
  int  mNcon_diff;
  // The following defined by KSG 11/05/04 to check for gaps within one minute
  bool  minute_gap;
  //The following two variables were added by KSG on 1/06/05 in order to
  //enable supression of filter ringdown for at least one minute trend after a
  //minute with a data gap
  int  minutes_since_gap;
  int  max_minutes_since;
  int  gap_size_t0;
  // 2/20/05 The following boolean varible added by ksg on 2/20/05
  // in order to order to mark filter ringdowns
  bool  ring_down;
};

#endif     //  BandMonitor_HH













