#include "MultiList.hh"
#include <fstream>
#include <string>
#include <iostream>
#include <sys/types.h>
#include <dirent.h>
#include <fnmatch.h>

using namespace std;

//======================================  Constructor
MultiList::MultiList(void) {
}

//======================================  Destructor
MultiList::~MultiList(void) {
    mList.clear();
}

//======================================  Compare filename to full path
inline int
filecmp(const char* file, const string& path) {
    const char* pstr = path.c_str();
    const char* fstart = pstr;
    while (*pstr) if (*(pstr++) == '/') fstart = pstr;
    while (*fstart && *fstart == *file ) {
        fstart++;
	file++;
    }
    if (*file > *fstart) return  1;
    if (*file < *fstart) return -1;
    return 0;
}

inline bool 
filelt(const char* file, const string& path) {
    return filecmp(file, path) < 0;
}

inline bool 
filegt(const char* file, const string& path) {
    return filecmp(file, path) > 0;
}

//======================================  Specify a data source to be read.
void 
MultiList::addMulti(const char* multinm) {
    if (!multinm || !*multinm) return;
    ifstream inl(multinm);
    long nStartList = mList.size();
    cout << "Processing multi list file: " << multinm << endl;
    string lname;
    while (inl.good()) {
        lname.clear();
        inl >> lname;
	if (!inl) break;
	while (lname.size() > 0 && lname[0] == ' ') lname.erase(0,1);
	int l = lname.size();
	if (l<=0 || lname[0] == '#') continue;
	while (l>0 && (lname[l-1]==' ' || lname[l-1]=='\n'))lname.erase(--l);
	if (l>0) mList.push_back(lname.c_str());
    }
    cout << "        Number of lists added: " << mList.size() - nStartList
	 << " Total data streams: " << mList.size() << endl;
}

//======================================  Specify a data source to be read.
void
MultiList::addSingle(const char* singlenm) {
    if (!singlenm || !*singlenm) return;
    mList.push_back( singlenm );
}
                                                                                                               
//======================================  Print the list list
std::ostream& 
MultiList::print(std::ostream& out) const {
    if (empty()) return out << "No lists requested." << endl;
    for (int i=0; i<mList.size(); i++) {
        out << mList[i] << endl;
    }
    return out;
}
